Subject: Re: [Sipping] Question on draft-ietf-sipping-v6-transition-07

From: "Elwell, John" <[email-masked]>
Date: Wed, 3 Feb 2010 17:07:29 +0100

Vijay,

A follow-up question on the statement:
"For this, IPv6 implementations MUST use a domain
       name within the .invalid DNS top-level domain instead of using
       the IPv6 unspecified address (i.e., ::)."
Presumably just "invalid" (alone, as opposed to "xxxx.invalid" would be legal?

John 

> -----Original Message-----
> From: Vijay K. Gurbani [mailto:[email-masked]] 
> Sent: 28 January 2010 20:10
> To: Elwell, John
> Cc: [email-masked]
> Subject: Re: [Sipping] Question on draft-ietf-sipping-v6-transition-07
> 
> Elwell, John wrote:
> > [JRE] Thanks, Vijay. However, RFC 3264 specifies only 
> 0.0.0.0 for the
> > case where the address is not known in the initial offer (I am not
> > talking about the deprecated use for hold). It does not specify
> > .invalid, so I don't know what you mean by two alternative 
> solutions.
> 
> Correct; rfc3264 does not specify .invalid.  sipping-v6-transition
> is supposed to update rfc3264 to do so.
> 
> The two alternative solutions are supporting "::" and ".invalid";
> since at the time of writing of sipping-v6-transition, there
> wasn't much IPv6 support, instead of mandating both ".invalid"
> and "::", we decided to mandate only the ".invalid".  Older,
> IPv4 endpoints could continue using "0.0.0.0" while newer
> IPv4/IPv6 endpoints will use "0.0.0.0" when communicating
> with IPv4 peers and ".invalid" when doing so with IPv6 peers.
> 
> Thanks,
> 
> - vijay
> -- 
> Vijay K. Gurbani, Bell Laboratories, Alcatel-Lucent
> 1960 Lucent Lane, Rm. 9C-533, Naperville, Illinois 60566 (USA)
> Email: vkg@{alcatel-lucent.com,bell-labs.com,acm.org}
> Web:   http://ect.bell-labs.com/who/vkg/
>

---

From: "Dale Worley" <[email-masked]>
Date: Thu, 04 Feb 2010 11:44:04 -0500

> Presumably just "invalid" (alone, as opposed to "xxxx.invalid" would be legal?

That would be the implication of the usual meaning of "within".  Looking
at RFC 1034 (DOMAIN NAMES - CONCEPTS AND FACILITIES), it doesn't appear
that "within" has a special, defined meaning in regard to domain names.

Dale

---

From: "Elwell, John" <[email-masked]>
Date: Fri, 5 Feb 2010 12:02:12 +0100

Vijay,

Thanks, but I was concerned that a domain name beginning with "." might be wrong; Taking the SIP ABNF as an example (SDP ABNF isn't so precise), we have:

hostname         =  *( domainlabel "." ) toplabel [ "." ] 

John

> From: Vijay K. Gurbani [mailto:[email-masked]] 
> Sent: 04 February 2010 20:37
> To: Elwell, John
> Cc: [email-masked]
> On 02/03/2010 10:07 AM, Elwell, John wrote:
> John: I think ".invalid" itself suffices, but I will defer to 
> Gonzalo's
> view on this.
> 
> Gonzalo: do you have an opinion.
> 
> Thanks,
> 
> - vijay
> --

---

From: "Kevin P. Fleming" <[email-masked]>
Date: Fri, 05 Feb 2010 09:03:10 -0600

> hostname         =  *( domainlabel "." ) toplabel [ "." ] 

That would in fact be wrong, domain names cannot begin with '.'. In
addition, I'd recommend against allowing an 'invalid' name that does not
contain '.', because many systems (including my laptop) are configured
with default DNS search domains that are searched when names that
contain only one component are resolved. 'invalid' in my case would
search in at least two domains for 'invalid.xxx.yyy', which is not
helpful in the context of this draft.

Explicitly specifying 'this.is.invalid' or something similar seems to be
prudent in this case.

-- 
Kevin P. Fleming
Digium, Inc. | Director of Software Technologies
445 Jan Davis Drive NW - Huntsville, AL 35806 - USA
skype: kpfleming | jabber: [email-masked]
Check us out at www.digium.com & www.asterisk.org

---

From: "Elwell, John" <[email-masked]>
Date: Fri, 5 Feb 2010 16:45:14 +0100

Thanks, that seems to make sense to me.

John 

> From: Kevin P. Fleming [mailto:[email-masked]] 
> Sent: 05 February 2010 15:03
> To: Elwell, John
> Cc: Vijay K. Gurbani; [email-masked]
> > Thanks, but I was concerned that a domain name beginning 
> with "." might be wrong; Taking the SIP ABNF as an example 
> (SDP ABNF isn't so precise), we have:
> >

---

From: "Vijay K. Gurbani" <[email-masked]>
Date: Fri, 05 Feb 2010 10:31:59 -0600

Elwell, John wrote:
> Thanks, but I was concerned that a domain name beginning with "."
> might be wrong; Taking the SIP ABNF as an example (SDP ABNF isn't so
> precise), we have:
> 

John: Quite true.  However, in the case we are talking about,
the ".invalid" appears in the SDP, which is governed by the
SDP ABNF.  The ".invalid" is not appearing in the URI, but
in the "c=" line in SDP.

The SDP ABNF in rfc4566 has this grammar for the
"c=" line:

connection-field =    [%x63 "=" nettype SP addrtype SP
                          connection-address CRLF]
connection-address =  multicast-address / unicast-address
unicast-address =     IP4-address / IP6-address / FQDN / extn-addr
extn-addr =           non-ws-string
non-ws-string =       1*(VCHAR/%x80-FF)
                       ;string of visible characters

Does not ".invalid" in the SDP result from the extn-addr
production rule above?  Consequently, should it not be legal?
Or am I missing something here?

Thanks,

- vijay

---

From: "Vijay K. Gurbani" <[email-masked]>
Date: Thu, 04 Feb 2010 14:37:04 -0600

> Presumably just "invalid" (alone, as opposed to "xxxx.invalid" would be legal?

John: I think ".invalid" itself suffices, but I will defer to Gonzalo's
view on this.

Thanks,

- vijay

---

From: "Elwell, John" <[email-masked]>
Date: Fri, 5 Feb 2010 17:44:06 +0100

Vijay,

Yes, I know we are talking SDP, but the SDP ABNF was so imprecise that I looked elsewhere. I am not sure where the definitive source is, but I just took SIP as an example, which seemed to suggest that the people who wrote RFC 3261 thought that a single element (without any dot) was wrong. This could mean that if you take a single element and use it as input to the DNS mechanism, you get the wrong outcome, and hence including a single element in SDP would be equally wrong. Kevin's message seems to support that belief.

John

> Sent: 05 February 2010 16:32
> To: Elwell, John
> Cc: [email-masked]

---

From: "Vijay K. Gurbani" <[email-masked]>
Date: Fri, 05 Feb 2010 11:15:25 -0600

Elwell, John wrote:
> Yes, I know we are talking SDP, but the SDP ABNF was so imprecise
> that I looked elsewhere. I am not sure where the definitive source
> is, but I just took SIP as an example, which seemed to suggest that
> the people who wrote RFC 3261 thought that a single element (without
> any dot) was wrong. 

John: I would believe the authors of rfc3261 focused on
the signaling itself and relegated the nuances of body handling
to appropriate mechanisms and documents.  We should probably
seek their opinion.

That said, I am not refuting your or Kevin's stance.  Clearly,
implementers opt for the path of least resistance, and this
dictates that they parse the token from SDP "c=" line and feed
it directly into the DNS routines (which will certainly hiccup
when given ".invalid").  However, pedantically speaking, the SDP
ABNF seems to indicate that ".invalid" is legal (at least to my
reading.)

Thus, when a developer armed with the pedantic interpretation
squares off against a developer armed with an implementation
that took the path of least resistance, who is right?  I am
sure you have been part of countless arguments where standards
say one thing and what is implemented is a bit ... well ...
different ;-)

Thanks,

- vijay

---

From: "Dale Worley" <[email-masked]>
Date: Fri, 05 Feb 2010 14:29:31 -0500

> John: I think ".invalid" itself suffices, but I will defer to Gonzalo's

Why have we put a leading "." on "invalid"?  We do not write, e.g.,
".bell-labs.com".  I know of no other place where a domain name is
written with a leading period.

Dale

---

From: "Somogyi, Gabor (NSN - HU/Budapest)" <[email-masked]>
Date: Mon, 8 Feb 2010 11:38:53 +0200

The dot before "invalid" indicates that "invalid" is a TLD. See also
section 2 of RFC 2606.

BTW, 3GPP TS 29.231 (http://3gpp.org/ftp/Specs/html-info/29231.htm)
describes the same for unspecified connection address.

So create whatever domain name you like within ".invalid" TLD. I think
"x.invalid" is a reasonably short one.

BR,
Som

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf Of ext Dale Worley
Sent: Friday, February 05, 2010 20:30
To: Vijay K. Gurbani
Cc: Elwell, John; [email-masked]
Subject: Re: [Sipping] Question on draft-ietf-sipping-v6-transition-07

On Thu, 2010-02-04 at 14:37 -0600, Vijay K. Gurbani wrote:
> Gonzalo's view on this.

Dale

_______________________________________________
Sipping mailing list  https://www.ietf.org/mailman/listinfo/sipping
This list is for NEW development of the application of SIP Use
[email-masked] for questions on current sip Use
[email-masked] for new developments of core SIP